#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#ifdef MEMDEBUG
#include <mnemosyn.h>
#endif
#define  TRUE (0==0)
#define  FALSE (0!=0)
#include "regexp.h"
#include "lextest.h"
#ifdef NO_MAIN

extern char **argv;
extern int argc;


extern FILE *yyin;
#else

char **argv = (char **)NULL;
int argc = 0;


FILE *yyin = NULL;
#endif /* MAIN */
#include "taccutil.h"


/* Main cheats - it invokes the parsing routines explicitly,
   in order to reduce the size of the parse tree for a whole
   file.  Also allows recovery of errors at useful boundaries */

 
  
int main_1(YYTYPE *__arg)
{
int __debug = SEEN_main_1 = debug_execute_enter("Executing procedure main_1 -- arg at %p", __arg);

    YYTYPE *subroot;
    void *stacktop;
    int i;

    if (strcmp(argv[argc-1], "-v") == 0) {
      argc -= 1;
      verbose = TRUE;
    }
    if (strcmp(argv[argc-1], "-d") == 0) {
      argc -= 1;
      _debug = TRUE;
    }
    if (strcmp(argv[argc-1], "-vd") == 0) {
      argc -= 1;
      _debug = TRUE;
      verbose = TRUE;
    }


    if (argc == 1) {
       yyin = fopen("bibtest", "r");
    } else if (argc != 2) {
       fprintf(stderr, "syntax: findsect  infile\n");
       /* Let's just resume for now... */
       yyin = fopen(argv[1], "r");
    } else {
       yyin = fopen(argv[1], "r");
    }
    if (yyin == NULL) {
       fprintf(stderr, "findsect: cannot open input\n");
       exit(EXIT_FAILURE);
    }

    fprintf(stderr, "%s: processing %s\n", argv[0], argv[1] == NULL ? "bibtest" : argv[1]);

    cur_handler = ignore;

    if (verbose) fprintf(stderr, "Starting\n");

    for (;;) {
      stacktop = stackmark();
      if (block_parse(&subroot)) {
          execute_parsetree(subroot);
      } else {
          return(FALSE);
      }
      stackrelease(stacktop);
      if (exit_flag) return(TRUE);
    }
  
if (!_optimise) debug_execute_exit("main_1");
return(TRUE);
}



             
int block_1(YYTYPE *__arg)
{
int __debug = SEEN_block_1 = debug_execute_enter("Executing procedure block_1 -- arg at %p", __arg);

                    int i;
                    exit_flag = TRUE;
                  
if (!_optimise) debug_execute_exit("block_1");
return(TRUE);
}
         
int block_2(YYTYPE *__arg)
{
int __debug = SEEN_block_2 = debug_execute_enter("Executing procedure block_2 -- arg at %p", __arg);

	 	    fprintf(stderr, "*** pqr...stu... %s!\n", ((USERTYPE *)(__arg->execute.arg[1]->execute.user_value)));
                  
if (!_optimise) debug_execute_exit("block_2");
return(TRUE);
}
           
int block_3(YYTYPE *__arg)
{
int __debug = SEEN_block_3 = debug_execute_enter("Executing procedure block_3 -- arg at %p", __arg);

                    if (((USERTYPE *)(__arg->execute.arg[2]->execute.user_value)) == NULL) {
	 	      fprintf(stderr, "Nothing between abc and def\n");
                    } else {
	 	      fprintf(stderr, "*** '%s' between abc and def!\n", ((USERTYPE *)(__arg->execute.arg[2]->execute.user_value)));
                    }
                  
if (!_optimise) debug_execute_exit("block_3");
return(TRUE);
}
         
int block_4(YYTYPE *__arg)
{
int __debug = SEEN_block_4 = debug_execute_enter("Executing procedure block_4 -- arg at %p", __arg);

	 	    fprintf(stderr, "%s!\n", __arg->execute.arg[1]->execute.text);
                  
if (!_optimise) debug_execute_exit("block_4");
return(TRUE);
}
          
int block_5(YYTYPE *__arg)
{
int __debug = SEEN_block_5 = debug_execute_enter("Executing procedure block_5 -- arg at %p", __arg);

                  
if (!_optimise) debug_execute_exit("block_5");
return(TRUE);
}


  
int middle_1(YYTYPE *__arg)
{
int __debug = SEEN_middle_1 = debug_execute_enter("Executing procedure middle_1 -- arg at %p", __arg);
 ((USERTYPE *)(__arg->execute.arg[0]->execute.user_value)) = __arg->execute.arg[1]->execute.text; 
if (!_optimise) debug_execute_exit("middle_1");
return(TRUE);
}



int main_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("main_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 0, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("main_parse found option 1 -- \"\" ");
      *__arg = makeparsetree(__temp, main_1, 1, "main", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("main_parse failed");
   return(FALSE);
}

int block_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("block_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& eof_parse(&__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("block_parse found option 1 -- ");
      *__arg = makeparsetree(__temp, block_1, 1, "block", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("block_parse - trying option 2"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 1, &__temp.execute.arg[1])
&& _regexp_parse(savepat, 2, &__temp.execute.arg[2])
)  {
      if (!_optimise) debug_exit("block_parse found option 2 -- ");
      *__arg = makeparsetree(__temp, block_2, 2, "block", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("block_parse - trying option 3"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 3, &__temp.execute.arg[1])
&& is(middle_parse,&__temp.execute.arg[2]) /* Lazy eval */
&& _regexp_parse(savepat, 4, &__temp.execute.arg[3])
&& _regexp_parse(savepat, 5, &__temp.execute.arg[4])
)  {
      if (!_optimise) debug_exit("block_parse found option 3 -- ");
      *__arg = makeparsetree(__temp, block_3, 4, "block", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("block_parse - trying option 4"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 6, &__temp.execute.arg[1])
&& _regexp_parse(savepat, 7, &__temp.execute.arg[2])
)  {
      if (!_optimise) debug_exit("block_parse found option 4 -- ");
      *__arg = makeparsetree(__temp, block_4, 2, "block", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   /*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
   if (!_optimise) debug_exit("block_parse - trying option 5"); lev += 1;

if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 8, &__temp.execute.arg[1])
&& _regexp_parse(savepat, 9, &__temp.execute.arg[2])
)  {
      if (!_optimise) debug_exit("block_parse found option 5 -- \".*\" \"$\" ");
      *__arg = makeparsetree(__temp, block_5, 2, "block", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("block_parse failed");
   return(FALSE);
}

int middle_parse(YYTYPE **__arg)
{
YYTYPE __temp;
int i;
long __pos;

void *__stack;

*__arg = NULL; /* Initialise in case of failure */
/*if (!_optimise)*/ for (i = 0; i < MAX_RULES; i++) __temp.execute.arg[i] = NULL;
if (!_optimise) debug_enter("middle_parse - trying option 1");
__stack = stackmark();
if (note_backtrack(&__pos)
&& _regexp_parse(savepat, 10, &__temp.execute.arg[1])
)  {
      if (!_optimise) debug_exit("middle_parse found option 1 -- \"123\" ");
      *__arg = makeparsetree(__temp, middle_1, 1, "middle", __LINE__);
      return(TRUE);
   }
   do_backtrack(__pos);
   stackrelease(__stack);
   if (!_optimise) debug_exit("middle_parse failed");
   return(FALSE);
}


static int cover_test(void)
{
if ((cover_testing) && (!SEEN_main_1)) LogWarning(ProgName, "lextest.e", 0, "Alternative 1 of rule main not tested\n");
if ((cover_testing) && (!SEEN_block_1)) LogWarning(ProgName, "lextest.e", 0, "Alternative 1 of rule block not tested\n");
if ((cover_testing) && (!SEEN_block_2)) LogWarning(ProgName, "lextest.e", 0, "Alternative 2 of rule block not tested\n");
if ((cover_testing) && (!SEEN_block_3)) LogWarning(ProgName, "lextest.e", 0, "Alternative 3 of rule block not tested\n");
if ((cover_testing) && (!SEEN_block_4)) LogWarning(ProgName, "lextest.e", 0, "Alternative 4 of rule block not tested\n");
if ((cover_testing) && (!SEEN_block_5)) LogWarning(ProgName, "lextest.e", 0, "Alternative 5 of rule block not tested\n");
if ((cover_testing) && (!SEEN_middle_1)) LogWarning(ProgName, "lextest.e", 0, "Alternative 1 of rule middle not tested\n");
}
#ifndef NO_MAIN  /* Get this by default */

int main(int local_argc, char **local_argv)
{
YYTYPE *root; /* Or could be a single YYTYPE, plus an explicit makeparsetree() */
int i;
   argv = local_argv; argc = local_argc;
   /* Should open file yyin here; do it in first entry routine *only* if
   it recognises the null phrase "" */
   if (main_parse(&root)) {
      dump_parsetree(root);
      execute_parsetree(root);
   } else {
      fprintf(stderr, "Parse fail\n");
      for (i = 0; i < 11; i++) if (savepat[i].r != NULL) free(savepat[i].r);
      exit(EXIT_FAILURE);
   }
   /*free_parsetree(root);*/ /*free(root);*/
   cover_test();
   exit(EXIT_SUCCESS);
}
#endif /* not NO_MAIN */

static void _regexp_freeall(void) {
int i;
   for (i = 0; i < 11; i++) if (savepat[i].r != NULL) free(savepat[i].r);
}
