#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

/* Shouldn't really put full path in here, but at the
   moment I'm tackily including this file from /usr/gtoal/card2sgm/card2sgm.l
 */
#include "log.h"

#define MAX_ERRMESS 4096

void ctrlclean(char *in)
{
static char tmp[MAX_ERRMESS];
char *s = in, *out = tmp;
int c;
  for (;;) {
    c = *s++;
    if (c == '\0') break;
    if ((c != '\n') && (c < 32)) {
      *out++ = '^'; *out++ = c + 'A' - 1;
    } else {
      *out++ = c;
    }
  }
  *out = '\0';
  strcpy(in, tmp);
}

static void errline(
  FILE *f,
  char *severity, char *source_file, int source_line,
  char *outbuf)
{
  if (source_line == -1) {
    fprintf(f, "%s %s: %s\n", severity, source_file, outbuf);
  } else {
    fprintf(f, "%s %s:%ld:\n   %s\n",
      severity, source_file, source_line, outbuf);
  }
}

#ifdef __riscos
#pragma -v1
#endif
void LogFatal(char *ProgName,
              char *source_file, long source_line,
              const char *fmt, ...)
{
static char outbuf[MAX_ERRMESS];
va_list arg_ptr;
FILE *logfile;
  va_start(arg_ptr,fmt);
  vsprintf(outbuf,fmt,arg_ptr);
  va_end(arg_ptr);
  if (*outbuf != '\0') {
    char *p = outbuf+strlen(outbuf)-1;
    if (*p == '\n') *p = '\0';
  }
  ctrlclean(outbuf);
  errline(stderr, "FATAL ERROR",
    source_file, source_line, outbuf);
  logfile = fopen("errors.log", "a");
  if (logfile != NULL) {
    errline(logfile, "FATAL ERROR",
      source_file, source_line, outbuf);
    fclose(logfile);
  }
}

#ifdef __riscos
#pragma -v1
#endif
void LogDataError(char *ProgName,
                  char *source_file, long source_line,
                  const char *fmt, ...)
{
static char outbuf[MAX_ERRMESS];
va_list arg_ptr;
FILE *logfile;
  va_start(arg_ptr,fmt);
  vsprintf(outbuf,fmt,arg_ptr);
  va_end(arg_ptr);
  if (*outbuf != '\0') {
    char *p = outbuf+strlen(outbuf)-1;
    if (*p == '\n') *p = '\0';
  }
  ctrlclean(outbuf);
  errline(stderr, "ERROR IN DATA FILE",
    source_file, source_line, outbuf);
  logfile = fopen("errors.log", "a");
  if (logfile != NULL) {
    errline(logfile, "ERROR IN DATA FILE",
      source_file, source_line, outbuf);
    fclose(logfile);
  }
}

#ifdef __riscos
#pragma -v1
#endif
void LogDataWarning(char *ProgName,
                    char *source_file, long source_line,
                    const char *fmt, ...)
{
static char outbuf[MAX_ERRMESS];
va_list arg_ptr;
FILE *logfile;
  va_start(arg_ptr,fmt);
  vsprintf(outbuf,fmt,arg_ptr);
  va_end(arg_ptr);
  if (*outbuf != '\0') {
    char *p = outbuf+strlen(outbuf)-1;
    if (*p == '\n') *p = '\0';
  }
  ctrlclean(outbuf);
  errline(stderr, "Data file warning",
    source_file, source_line, outbuf);
  logfile = fopen("errors.log", "a");
  if (logfile != NULL) {
    errline(logfile, "Data file warning",
      source_file, source_line, outbuf);
    fclose(logfile);
  }
}

#ifdef __riscos
#pragma -v1
#endif
void LogError(char *ProgName,
              char *source_file, long source_line,
              const char *fmt, ...)
{
static char outbuf[MAX_ERRMESS];
va_list arg_ptr;
FILE *logfile;
  va_start(arg_ptr,fmt);
  vsprintf(outbuf,fmt,arg_ptr);
  va_end(arg_ptr);
  if (*outbuf != '\0') {
    char *p = outbuf+strlen(outbuf)-1;
    if (*p == '\n') *p = '\0';
  }
  ctrlclean(outbuf);
  errline(stderr, "PROGRAM ERROR",
    source_file, source_line, outbuf);
  logfile = fopen("errors.log", "a");
  if (logfile != NULL) {
    errline(logfile, "PROGRAM ERROR",
      source_file, source_line, outbuf);
    fclose(logfile);
  }
}

#ifdef __riscos
#pragma -v1
#endif
void LogWarning(char *ProgName,
                char *source_file, long source_line,
                const char *fmt, ...)
{
static char outbuf[MAX_ERRMESS];
va_list arg_ptr;
FILE *logfile;

  va_start(arg_ptr,fmt);
  vsprintf(outbuf,fmt,arg_ptr);
  va_end(arg_ptr);
  if (*outbuf != '\0') {
    char *p = outbuf+strlen(outbuf)-1;
    if (*p == '\n') *p = '\0';
  }
  ctrlclean(outbuf);
  errline(stderr, "Program warning",
    source_file, source_line, outbuf);
  logfile = fopen("errors.log", "a");
  if (logfile != NULL) {
    errline(logfile, "Program warning",
      source_file, source_line, outbuf);
    fclose(logfile);
  }
}

